import "../chunk-G2ADBYYC.js";
import {
  getCalendarDays,
  computedCurrentRow,
  computedFilteredCalendarDays,
  handleDraggerClick,
  handleClickDay,
  calcCalendarItemHeight,
  computedTotalRows,
  handleDraggerMousedown,
  handleMouseup,
  handleMousemove,
  handleDraggerTouchstart,
  handleDraggerTouchend,
  handleDraggerTouchmove,
  setCascaderVisible,
  handleCascaderChange,
  computeCascaderOptions,
  i18nYearMonth
} from "./index";
import throttle from "../common/deps/throttle";
const api = [
  "state",
  "handleDraggerClick",
  "handleClickDay",
  "handleDraggerMousedown",
  "handleDraggerTouchstart",
  "handleDraggerTouchend",
  "throttledHandleDraggerTouchmove",
  "setCascaderVisible",
  "handleCascaderChange",
  "i18nYearMonth"
];
const renderless = (props, { reactive, computed, onBeforeMount, onMounted }, { emit, vm, t }) => {
  const state = reactive({
    minSize2: "min-width: 3rem; min-height: 2rem",
    minSize3: "min-width: 3rem; min-height: 3rem",
    dayOfWeek: 7,
    weekDays: [],
    calendarDays: [],
    currentYear: "",
    currentMonth: "",
    currentRow: computed(() => api2.computedCurrentRow()),
    filteredCalendarDays: computed(() => api2.computedFilteredCalendarDays()),
    visibleRows: [],
    itemHeight: 0,
    totalRows: computed(() => api2.computedTotalRows()),
    dragging: false,
    touching: false,
    cascaderCurrent: [],
    cascaderOptions: computed(() => api2.computeCascaderOptions()),
    cascaderVisible: false
  });
  const api2 = {
    state,
    getCalendarDays: getCalendarDays(state),
    computedCurrentRow: computedCurrentRow(state),
    computedFilteredCalendarDays: computedFilteredCalendarDays(state),
    handleDraggerClick: handleDraggerClick(state),
    calcCalendarItemHeight: calcCalendarItemHeight({ state, vm }),
    computedTotalRows: computedTotalRows(state),
    throttledHandleMousemove: throttle(20, handleMousemove({ state, vm })),
    handleDraggerTouchstart: handleDraggerTouchstart({ state, vm }),
    handleDraggerTouchend: handleDraggerTouchend({ state, vm }),
    throttledHandleDraggerTouchmove: throttle(20, handleDraggerTouchmove({ state, vm })),
    setCascaderVisible: setCascaderVisible(state),
    computeCascaderOptions: computeCascaderOptions(t),
    i18nYearMonth: i18nYearMonth({ state, t })
  };
  Object.assign(api2, {
    handleClickDay: handleClickDay({ api: api2, emit, props }),
    handleDraggerMousedown: handleDraggerMousedown({ api: api2, state, vm }),
    handleMouseup: handleMouseup({ api: api2, state, vm }),
    handleCascaderChange: handleCascaderChange({ api: api2, emit, props, state })
  });
  onBeforeMount(() => {
    api2.getCalendarDays(props.modelValue, props.config);
  });
  onMounted(() => {
    api2.calcCalendarItemHeight();
  });
  return api2;
};
export {
  api,
  renderless
};
