import "../chunk-G2ADBYYC.js";
const handleExpand = (state) => (e) => state.activeNode = e.target;
const handleMouseMove = ({
  api,
  parent,
  refs,
  state,
  svg
}) => (e) => {
  const { hoverZone } = refs;
  if (!state.activeNode || !hoverZone) {
    return;
  }
  if (state.activeNode.contains(e.target)) {
    if (state.hoverTimer) {
      clearTimeout(state.hoverTimer);
    }
    const { left } = refs.cascaderMenu.$parent.$el.getBoundingClientRect();
    const startX = e.clientX - left;
    const { offsetWidth, offsetHeight } = refs.cascaderMenu.$parent.$el;
    const top = state.activeNode.offsetTop;
    const bottom = top + state.activeNode.offsetHeight;
    hoverZone.innerHTML = `
      ${svg}${startX} ${top} L${offsetWidth} 0 V${top} Z" />
      ${svg}${startX} ${bottom} L${offsetWidth} ${offsetHeight} V${bottom} Z" />
    `;
  } else if (!state.hoverTimer) {
    state.hoverTimer = setTimeout(api.clearHoverZone, parent.state.config.hoverThreshold);
  }
};
const clearHoverZone = (refs) => () => {
  const { hoverZone } = refs;
  if (!hoverZone) {
    return;
  }
  hoverZone.innerHTML = "";
};
export {
  clearHoverZone,
  handleExpand,
  handleMouseMove
};
