import "../../chunk-G2ADBYYC.js";
const calcLeftByAlpha = (wrapper, thumb, alpha) => {
  return Math.round(
    alpha * (wrapper.offsetWidth - thumb.offsetWidth / 2) / 100
  );
};
const updateThumb = (alpha, thumb, wrapper) => {
  thumb.style.left = `${calcLeftByAlpha(wrapper, thumb, alpha)}px`;
};
const onDrag = (event, bar, thumb, alpha) => {
  const rect = bar.value.getBoundingClientRect();
  const { clientX } = event;
  let left = clientX - rect.left;
  left = Math.max(thumb.value.offsetWidth / 2, left);
  left = Math.min(left, rect.width - thumb.value.offsetWidth / 2);
  alpha.value = Math.round(
    (left - thumb.value.offsetWidth / 2) / (rect.width - thumb.value.offsetWidth) * 100
  );
};
export {
  calcLeftByAlpha,
  onDrag,
  updateThumb
};
