import "../chunk-G2ADBYYC.js";
const onConfirm = (hex, triggerBg, res, emit, isShow) => {
  return (color) => {
    res.value = color;
    hex.value = res.value;
    triggerBg.value = res.value;
    emit("confirm", res.value);
    isShow.value = false;
  };
};
const onCancel = (res, triggerBg, emit, isShow, hex, color) => {
  return () => {
    if (isShow.value) {
      res.value = triggerBg.value;
      hex.value = triggerBg.value;
      color.reset(hex.value);
      emit("cancel");
    }
    isShow.value = false;
  };
};
const onColorUpdate = (color, res, triggerBg) => {
  res.value = color.getHex();
};
const onHSVUpdate = (color, res, hex) => {
  return {
    onHueUpdate: (hue) => {
      color.set({ h: hue });
      onColorUpdate(color, res);
      hex.value = color.getHex();
    },
    onSVUpdate: ({ s, v }) => {
      color.set({ s, v });
      onColorUpdate(color, res);
    }
  };
};
const onAlphaUpdate = (color, res) => {
  return {
    update: (alpha) => {
      color.set({ a: alpha });
      onColorUpdate(color, res);
    }
  };
};
export {
  onAlphaUpdate,
  onCancel,
  onColorUpdate,
  onConfirm,
  onHSVUpdate
};
