import "../chunk-G2ADBYYC.js";
import Color from "./utils/color";
import { onConfirm, onCancel, onHSVUpdate, onAlphaUpdate } from ".";
const api = [
  "state",
  "changeVisible",
  "cursor",
  "onColorUpdate",
  "onHueUpdate",
  "onSVUpdate",
  "onConfirm",
  "onCancel",
  "onAlphaUpdate",
  "alpha"
];
const renderless = (props, context, { emit }) => {
  var _a, _b, _c, _d;
  const { modelValue, visible } = context.toRefs(props);
  const hex = context.ref((_a = modelValue.value) != null ? _a : "transparent");
  const res = context.ref((_b = modelValue.value) != null ? _b : "transparent");
  const triggerBg = context.ref((_c = modelValue.value) != null ? _c : "transparent");
  const isShow = context.ref((_d = visible == null ? void 0 : visible.value) != null ? _d : false);
  const cursor = context.ref();
  const changeVisible = (state2) => {
    isShow.value = state2;
  };
  const color = new Color(hex.value, props.alpha);
  const state = context.reactive({
    isShow,
    hex,
    color,
    triggerBg,
    defaultValue: modelValue,
    res
  });
  context.watch(modelValue, (newValue) => {
    hex.value = newValue;
    res.value = newValue;
    triggerBg.value = newValue;
    color.reset(hex.value);
  });
  context.watch(visible, (visible2) => {
    isShow.value = visible2;
  });
  const { onHueUpdate, onSVUpdate } = onHSVUpdate(color, res, hex);
  const { update } = onAlphaUpdate(color, res);
  const api2 = {
    state,
    changeVisible,
    onHueUpdate,
    onSVUpdate,
    onConfirm: onConfirm(hex, triggerBg, res, emit, isShow),
    onCancel: onCancel(res, triggerBg, emit, isShow, hex, color),
    onAlphaUpdate: update,
    cursor,
    alpha: props.alpha
  };
  return api2;
};
export {
  api,
  renderless
};
