import "../chunk-G2ADBYYC.js";
const onConfirm = (hex, triggerBg, res, emit, stack, enableHistory) => {
  return () => {
    hex.value = res.value;
    triggerBg.value = res.value;
    if (enableHistory) {
      const itemIdx = Math.max(stack.value.indexOf(res.value), stack.value.indexOf(res.value.toLowerCase()), stack.value.indexOf(res.value.toUpperCase()));
      if (itemIdx !== -1) {
        stack.value.splice(itemIdx, 1);
      }
      stack.value.unshift(res.value);
    }
    emit("confirm", res.value);
  };
};
const onCancel = (res, triggerBg, emit, isShow, hex, color) => {
  return () => {
    if (isShow.value) {
      res.value = triggerBg.value;
      hex.value = triggerBg.value;
      color.reset(hex.value);
      emit("cancel");
    }
  };
};
const onColorUpdate = (color, res) => {
  res.value = color.getHex();
};
const onHSVUpdate = (color, res, hex, emit) => {
  return {
    onHueUpdate: (hue) => {
      color.set({ h: hue });
      onColorUpdate(color, res);
      hex.value = color.getHex();
      emit("hue-update", hue);
    },
    onSVUpdate: ({ s, v }) => {
      color.set({ s, v });
      onColorUpdate(color, res);
      emit("sv-update", { s, v });
    }
  };
};
const onAlphaUpdate = (color, res) => {
  return {
    update: (alpha) => {
      color.set({ a: alpha });
      onColorUpdate(color, res);
    }
  };
};
const handleHistoryClick = (hex, res, color) => {
  return (history) => {
    hex.value = history;
    res.value = history;
    color.reset(history);
  };
};
const handlePredefineClick = (hex, res, color) => {
  return (selectedColor) => {
    hex.value = selectedColor;
    res.value = selectedColor;
    color.reset(selectedColor);
  };
};
export {
  handleHistoryClick,
  handlePredefineClick,
  onAlphaUpdate,
  onCancel,
  onColorUpdate,
  onConfirm,
  onHSVUpdate
};
