import "../chunk-G2ADBYYC.js";
import {
  mountedHandler,
  beforeUnmountHandler,
  handlerModelValue,
  onTouchstart,
  onTouchmove,
  onTouchend,
  initPullRefresh,
  clearPullRefresh
} from "./index";
const api = ["state"];
const renderless = (props, { watch, onMounted, reactive, onBeforeUnmount }, { t, refs }) => {
  const api2 = {};
  const state = reactive({
    pullUpReplaces: "",
    pullDownReplaces: "",
    refreshStyle: {},
    translate3d: 0,
    draggposition: 0,
    pullUpLoading: false,
    pullDownLoading: false,
    loosingText: "",
    successText: "",
    failedText: "",
    noMoreText: "",
    pullUp: null,
    pullDown: null,
    successDuration: props.successDuration,
    animationDuration: props.animationDuration
  });
  Object.assign(api2, {
    state,
    onTouchstart: onTouchstart(state),
    onTouchmove: onTouchmove({ props, state }),
    onTouchend: onTouchend({ api: api2, props, state }),
    mountedHandler: mountedHandler({ api: api2, refs }),
    beforeUnmountHandler: beforeUnmountHandler({ api: api2, refs }),
    handlerModelValue: handlerModelValue({ api: api2, state }),
    initPullRefresh: initPullRefresh({ t, props, state }),
    clearPullRefresh: clearPullRefresh(state)
  });
  watch(
    () => props.hasMore,
    (value) => {
      if (!value) {
        state.noMoreText = t("ui.pullRefresh.noMore");
        api2.clearPullRefresh();
      }
    }
  );
  onMounted(() => {
    api2.mountedHandler({ api: api2, refs, state });
    api2.initPullRefresh({ t, props, state });
  });
  onBeforeUnmount(api2.beforeUnmountHandler);
  return api2;
};
export {
  api,
  renderless
};
