import { ExtractPropTypes } from 'vue';
import { ISharedRenderlessFunctionParams, ISharedRenderlessParamUtils } from './shared.type.mjs';

declare const $constants: {
    COMPONENT_NAME: {
        Collapse: string;
    };
    EVENT_NAME: {
        CollapseItemClick: string;
    };
};
declare const collapseProps: {
    _constants: {
        type: ObjectConstructor;
        default: () => {
            COMPONENT_NAME: {
                Collapse: string;
            };
            EVENT_NAME: {
                CollapseItemClick: string;
            };
        };
    };
    accordion: BooleanConstructor;
    beforeClose: FunctionConstructor;
    modelValue: {
        type: (ArrayConstructor | StringConstructor | NumberConstructor)[];
        default: () => never[];
    };
    tiny_mode: StringConstructor;
    tiny_mode_root: BooleanConstructor;
    tiny_template: (FunctionConstructor | ObjectConstructor)[];
    tiny_renderless: FunctionConstructor;
    tiny_theme: StringConstructor;
    tiny_chart_theme: ObjectConstructor;
};

type ICollapseProps = ExtractPropTypes<typeof collapseProps>;
type ICollapseConstants = typeof $constants;
interface ICollapseState {
    activeNames: Array<string>;
}
type ICollapseRenderlessParams = ISharedRenderlessFunctionParams<ICollapseConstants> & {
    api: ICollapseApi;
    state: ICollapseState;
    props: ICollapseProps;
    constants: ICollapseConstants;
};
interface ICollapseApi {
    state: ICollapseState;
    setActiveNames: (activeName: string[] | string) => void;
    handleItemClick: (item?: Object) => void;
}
type ICollapseRenderlessParamUtils = ISharedRenderlessParamUtils<ICollapseConstants>;

export { ICollapseApi, ICollapseConstants, ICollapseProps, ICollapseRenderlessParamUtils, ICollapseRenderlessParams, ICollapseState };
