import { ExtractPropTypes, ComputedRef } from 'vue';
import { ISharedRenderlessFunctionParams, ISharedRenderlessParamUtils } from './shared.type.mjs';

declare const linkProps: {
    type: {
        type: StringConstructor;
        default: string;
    };
    underline: {
        type: BooleanConstructor;
        default: boolean;
    };
    href: StringConstructor;
    icon: (StringConstructor | ObjectConstructor)[];
    disabled: BooleanConstructor;
    tiny_mode: StringConstructor;
    tiny_mode_root: BooleanConstructor;
    tiny_template: (FunctionConstructor | ObjectConstructor)[];
    tiny_renderless: FunctionConstructor;
    tiny_theme: StringConstructor;
    tiny_chart_theme: ObjectConstructor;
};

type ILinkProps = ExtractPropTypes<typeof linkProps>;
interface ILinkState {
    formDisabled: ComputedRef<boolean>;
    disabled: ComputedRef<boolean>;
}
interface ILinkApi {
    state: ILinkState;
    handleClick: (event: MouseEvent) => void;
}
type ILinkRenderlessParams = ISharedRenderlessFunctionParams<never> & {
    api: ILinkApi;
    state: ILinkState;
    props: ILinkProps;
};
type ILinkRenderlessParamUtils = ISharedRenderlessParamUtils<never>;

export { ILinkApi, ILinkProps, ILinkRenderlessParamUtils, ILinkRenderlessParams, ILinkState };
